#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

void kernel_cpu(int *A0,int *A1,int *A2,int *A3,int *A4,int *A5,int *A6,int *A7,int *A8,float *B0,float *B1,float *B2,float *B3,float *B4,float *B5,float *B6,float *B7,float *B8,int N){
for(int i=0;i<N;i++){
A0[i] = A4[i]*A6[i];
A1[i] = A5[i]*A5[i];
A2[i] = A4[i]/A3[i];
B0[i] = B8[i]+B8[i];
B1[i] = B8[i];
B2[i] = B8[i];
B3[i] = B8[i]+B8[i]/B8[i]+B8[i];
B4[i] = B8[i]/B8[i]/B8[i];
B5[i] = B8[i]-B8[i];
B6[i] = B8[i]*B8[i];
B7[i] = B8[i]*B8[i];
}
}

int main(int argc,char **argv) {
int size=296332;
int intBytes = size*sizeof(int);
int floatBytes = size*sizeof(float);
int *A0;
A0 = (int *)malloc(intBytes);
int *A1;
A1 = (int *)malloc(intBytes);
int *A2;
A2 = (int *)malloc(intBytes);
int *A3;
A3 = (int *)malloc(intBytes);
int *A4;
A4 = (int *)malloc(intBytes);
int *A5;
A5 = (int *)malloc(intBytes);
int *A6;
A6 = (int *)malloc(intBytes);
int *A7;
A7 = (int *)malloc(intBytes);
int *A8;
A8 = (int *)malloc(intBytes);
float *B0;
B0 = (float *)malloc(floatBytes);
float *B1;
B1 = (float *)malloc(floatBytes);
float *B2;
B2 = (float *)malloc(floatBytes);
float *B3;
B3 = (float *)malloc(floatBytes);
float *B4;
B4 = (float *)malloc(floatBytes);
float *B5;
B5 = (float *)malloc(floatBytes);
float *B6;
B6 = (float *)malloc(floatBytes);
float *B7;
B7 = (float *)malloc(floatBytes);
float *B8;
B8 = (float *)malloc(floatBytes);
for(int i=0;i<296332;i++){
A0[i] = 65*i+1;
A1[i] = 31+i+1;
A2[i] = 2*i+1;
A3[i] = 99+i+1;
A4[i] = 22*i+1;
A5[i] = 67+i+1;
A6[i] = 15*i+1;
A7[i] = 68+i+1;
A8[i] = 20+i+1;
B0[i] = 47.9864224501*i+1;
B1[i] = 9.11908966128+i+1;
B2[i] = 64.5071331925*i+1;
B3[i] = 90.4198335982+i+1;
B4[i] = 37.5476232789*i+1;
B5[i] = 52.4142499985*i+1;
B6[i] = 53.4016584948+i+1;
B7[i] = 47.658466834*i+1;
B8[i] = 55.8745096298*i+1;
}
struct timeval time0,time1;
gettimeofday(&time0,NULL);
FILE *file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "1";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
kernel_cpu(A0,A1,A2,A3,A4,A5,A6,A7,A8,B0,B1,B2,B3,B4,B5,B6,B7,B8,296332);
file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "0";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
gettimeofday(&time1,NULL);
double totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "CPU time: %lf msecs ",  (totaltime10)/1000.0F); 
free(A0);
free(A1);
free(A2);
free(A3);
free(A4);
free(A5);
free(A6);
free(A7);
free(A8);
free(B0);
free(B1);
free(B2);
free(B3);
free(B4);
free(B5);
free(B6);
free(B7);
free(B8);
printf("\n");return 0; }